import pygame, math, random
import text, var

def go1(screen):
  pygame.event.clear()
  messages = ["Once upon a time, on a colorful world....",
    "...a world with a serious color coordination problem....",
    "...things were about to get...",
    "monochromatic."]
  text.addmessage("Once upon a time, on a brightly colored world....", var.white, var.xv2, var.yv2)
  for m in messages:
    text.addmessage(m, var.white, var.xv2, var.yv2)
    going = True
    while going:
      screen.fill(var.black)
      going = text.update(screen)
      pygame.display.flip()
      if pygame.event.peek(pygame.KEYUP): return False
      pygame.event.pump()

  backdrop = pygame.image.load("media-lab-backdrop.png").convert_alpha()
  victim = pygame.image.load("victim-1.png").convert_alpha()
  foreground = pygame.image.load("media-lab-foreground.png").convert_alpha()
  h = var.yv2 - backdrop.get_height()/2

  messages = ["Hey, did someone spill something over here?",
    "Over by the self-replicating, self-programming nano-robot station?",
    "What is this stuff?"]
  xvic, yvic = 320, h+140
  j = 0
  for m in messages:
    text.addmessage(m, var.white, var.xv2, var.yv - 100)
    going = True
    while going:
      screen.fill(var.black)
      screen.blit(backdrop, (0, h))
      screen.blit(victim, (xvic, yvic))
      screen.blit(foreground, (0, h))
      going = text.update(screen)
      pygame.display.flip()
      if pygame.event.peek(pygame.KEYUP): return False
      pygame.event.pump()
      if j == 2:
        xvic -= 0.04
        yvic += 0.04
    j += 1
  return True

def go2(screen, view, view2):
  messages = ["Ugh, some of it got on me! Ouch, that stings.",
    "Hey can someone help me with this? It's really starting to hurt!",
    "OW! MY ARM! MY ARM IS ON FIRE!",
    "OH MY GOD THEY'RE USING MY ATOMS!",
    "PAIN!!!! SOMEONE KILL ME! KILL ME! JUST MAKE IT STOP!",
    "AAAAAAAAAAAAAAAAAAAA!!!!!!!!!!!!!!!"]
  for m in messages:
    text.addmessage(m, var.black, var.xv2, var.yv2 + 100)
    going = True
    while going:
      screen.blit(view, (0,0))
      going = text.update(screen)
      pygame.display.flip()
      if pygame.event.peek(pygame.KEYUP): return False
      pygame.event.pump()
  pausetime = pygame.time.get_ticks() + 1000
  while pygame.time.get_ticks() < pausetime:
    if pygame.event.peek(pygame.KEYUP): return False  
    pygame.event.pump()

  text.addmessage("One hour later....", var.black, var.xv2, var.yv2 + 100)
  going = True
  while going:
    screen.blit(view2, (0,0))
    going = text.update(screen)
    pygame.display.flip()
    if pygame.event.peek(pygame.KEYUP): return False
    pygame.event.pump()

  return True
  
def showtitle(screen):
  pygame.event.clear()
  screen.fill(var.black)
  title = pygame.image.load("title.png").convert()
  title = pygame.transform.scale(title, (title.get_width() * 16, title.get_height() * 16))
  screen.blit(title, (var.xv2 - title.get_width()/2, var.yv2 - title.get_height()/2))
  tabox = text.smallfont.render("a game by Christopher Night", True, var.white)
  screen.blit(tabox, (var.xv2 - title.get_width()/3, var.yv2 + title.get_height()*0.41))
  pygame.display.flip()
  while not pygame.event.peek(pygame.KEYUP):
    pygame.event.pump()

def ending(screen):
  sfield = screen.copy()
  sfield.fill(var.black)
  for y in xrange(0, screen.get_height()):
    x = random.randint(0, screen.get_width())
    sfield.set_at((x,y), var.white)
  pygame.draw.circle(sfield, var.grey, (sfield.get_width()/2, sfield.get_height() + 5000), 5100)
  for j in range(50, screen.get_height()/2):
    screen.blit(sfield, (0,0))
    pygame.draw.circle(screen, var.white, (sfield.get_width()/2, sfield.get_height() - 2*j), 4)
    pygame.display.flip()
  messages = ["Congratulations! You've left behind the grey world!",
    "Just hope you're the only ones to do so.",
    "The end...?"]
  for m in messages:
    text.addmessage(m, var.white, var.xv2, var.yv2)
    going = True
    while going:
      screen.blit(sfield, (0,0))
      going = text.update(screen)
      pygame.display.flip()

  x = random.randint(100, screen.get_width() - 100)
  y = screen.get_height()
  t0 = pygame.time.get_ticks()
  pygame.event.clear()
  while not pygame.event.peek(pygame.KEYUP):
    pygame.event.clear()
    screen.blit(sfield, (0,0))
    pygame.draw.circle(screen, var.grey, (x + int(6 * math.sin((pygame.time.get_ticks() - t0) / 50.)), y), 2)
    pygame.display.flip()
    y -= 1
    if y < 0:
      x = random.randint(100, screen.get_width() - 100)
      y = screen.get_height()
    


